SystemOrganization addCategory: #TusLibros!

TestCase subclass: #TusLibrosTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TusLibros'!

!TusLibrosTest methodsFor: 'cart' stamp: 'FedericoMendez 6/5/2013 11:08'!
anotherCartWithBooks
	
	| cart |
	cart := self anotherEmptyCart .
	cart add: self bookFromEditorial.
	cart add: self otherBookFromEditorial .
	^ cart! !

!TusLibrosTest methodsFor: 'cart' stamp: 'FedericoMendez 6/5/2013 11:07'!
anotherEmptyCart
	| aCataloge |
	aCataloge := self cataloge.
	^ Cart fromClient: '123456' whichMustHaveBooksFrom: aCataloge! !

!TusLibrosTest methodsFor: 'credit card' stamp: 'FedericoMendez 6/5/2013 10:03'!
anotherValidCreditCard
	
	| expiredDate |
	expiredDate := Date today month next next .
	^ CreditCard withNumber: '0000000000000001' withExpirationDate: expiredDate propertyOf: 'Juan Perez'! !

!TusLibrosTest methodsFor: 'books' stamp: 'TomasRodriguez 6/4/2013 11:10'!
bookFromEditorial
	
	^ 147896325! !

!TusLibrosTest methodsFor: 'books' stamp: 'TomasRodriguez 6/4/2013 10:39'!
bookFromOtherEditorial
	
	^ 9283478920
! !

!TusLibrosTest methodsFor: 'cart' stamp: 'FedericoMendez 6/4/2013 13:53'!
cartWithBooks
	
	| cart |
	cart := self emptyCart .
	cart add: self bookFromEditorial.
	cart add: self bookFromEditorial.
	cart add: self bookFromEditorial.
	cart add: self otherBookFromEditorial .
	^ cart! !

!TusLibrosTest methodsFor: 'cashier' stamp: 'FedericoMendez 6/4/2013 23:18'!
cashierWithEmptyCart
	^ Cashier withCart: self emptyCart creditCard: '' andSalesBook: ''! !

!TusLibrosTest methodsFor: 'cashier' stamp: 'FedericoMendez 6/4/2013 23:18'!
cashierWithExpiredCreditCard
	^ Cashier withCart: self cartWithBooks creditCard: self expiredCreditCard andSalesBook: ''! !

!TusLibrosTest methodsFor: 'catalogue' stamp: 'FedericoMendez 6/4/2013 14:03'!
cataloge
	
	| aDictionary |
	aDictionary := Dictionary  new.
	aDictionary at: 147896325 put: 100.
	aDictionary at: 369874125 put: 150.
	aDictionary at: 9874563210 put: 280.
	aDictionary at: 172839465 put: 75.
	^ Cataloge withBooks: aDictionary.! !

!TusLibrosTest methodsFor: 'cart' stamp: 'FedericoMendez 6/4/2013 22:56'!
emptyCart
	| aCataloge |
	aCataloge := self cataloge.
	^ Cart fromClient: '853241' whichMustHaveBooksFrom: aCataloge! !

!TusLibrosTest methodsFor: 'credit card' stamp: 'TomasRodriguez 6/4/2013 12:51'!
expiredCreditCard
	
	| expiredDate |
	expiredDate := Date today month previous previous .
	^ CreditCard withNumber: '9600000000000000' withExpirationDate: expiredDate propertyOf: 'Inspector Archundia'! !

!TusLibrosTest methodsFor: 'credit card' stamp: 'TomasRodriguez 6/4/2013 13:06'!
invalidNameCreditCard 

	^ CreditCard withNumber: '2854125469753125' withExpirationDate: (Date today month) propertyOf: 'A'! !

!TusLibrosTest methodsFor: 'credit card' stamp: 'TomasRodriguez 6/4/2013 13:04'!
invalidNumberCreditCard 

	^ CreditCard withNumber: '2' withExpirationDate: (Date today month) propertyOf: 'Carlos Falso'! !

!TusLibrosTest methodsFor: 'books' stamp: 'TomasRodriguez 6/4/2013 11:32'!
otherBookFromEditorial
	
	^ 369874125! !

!TusLibrosTest methodsFor: '1 - Test Cart' stamp: 'TomasRodriguez 6/4/2013 11:49'!
test01CartShouldBeEmptyWhenCreated 

	self assert: self emptyCart isEmpty .! !

!TusLibrosTest methodsFor: '1 - Test Cart' stamp: 'TomasRodriguez 6/4/2013 11:49'!
test02AddingABookFromOtherEditorialShouldRaiseCanNotAddABookFromOtherEditorialToTheCartException

	| cart book |
	cart := self emptyCart.
	book := self bookFromOtherEditorial.
	
	[cart add: book.
	self fail] on: Error do: [ :anError |
			self assert: cart isEmpty .
			self assert: anError class = CanNotAddABookFromOtherEditorialToTheCart ]! !

!TusLibrosTest methodsFor: '1 - Test Cart' stamp: 'TomasRodriguez 6/4/2013 11:49'!
test03AddingABookFromTheEditorialShouldAddItToTheCart

	| aCart aBook |
	aCart := self emptyCart.
	aBook := self bookFromEditorial.
	aCart add: aBook.
	
	self deny: aCart isEmpty .
	self assert: (aCart ocurrencesOf: aBook) = 1.
	self assert: aCart booksQuantity = 1! !

!TusLibrosTest methodsFor: '1 - Test Cart' stamp: 'TomasRodriguez 6/4/2013 11:49'!
test04AddingABookFromTheEditorialTwiceShouldAddItToTheCartTwoTimes

	| aCart aBook |
	aCart := self emptyCart.
	aBook := self bookFromEditorial.
	aCart add: aBook.
	aCart add: aBook.
	
	self deny: aCart isEmpty .
	self assert: (aCart ocurrencesOf: aBook) = 2.
	self assert: aCart booksQuantity = 2! !

!TusLibrosTest methodsFor: '1 - Test Cart' stamp: 'TomasRodriguez 6/4/2013 11:49'!
test05AddingTwoDifferentBooksShouldAddBothBooksToTheCart

	| aCart aBook otherBook |
	aCart := self emptyCart.
	aBook := self bookFromEditorial.
	otherBook := self otherBookFromEditorial.
	aCart add: aBook.
	aCart add: otherBook.
	
	self deny: aCart isEmpty .
	self assert: (aCart ocurrencesOf: aBook) = 1.
	self assert: (aCart ocurrencesOf: otherBook) = 1.
	self assert: aCart booksQuantity = 2! !

!TusLibrosTest methodsFor: '2 - Test CreditCard' stamp: 'TomasRodriguez 6/4/2013 13:07'!
test06CreatingACreditCardWithAnInvalidNumberShouldRaiseCanNotCreateACreditCardWithAnInvalidNumberException 

	self should: [self invalidNumberCreditCard  ] raise: CanNotCreateACreditCardWithAnInvalidNumber! !

!TusLibrosTest methodsFor: '2 - Test CreditCard' stamp: 'TomasRodriguez 6/4/2013 13:06'!
test07CreatingACreditCardWithAnInvalidNameShouldRaiseCanNotCreateACreditCardWithAnInvalidNameException 

	self should: [self invalidNameCreditCard ] raise: CanNotCreateACreditCardWithAnInvalidName ! !

!TusLibrosTest methodsFor: '2 - Test CreditCard' stamp: 'TomasRodriguez 6/4/2013 13:12'!
test08AValidCreditCardCanBeCreated

	| number date owner creditCard |
	
	number := '7854236501495723'.
	date := Date today next next.
	owner := 'Juanito Mouse'.
	creditCard := CreditCard withNumber: number withExpirationDate: date propertyOf: owner.
	
	self assert: creditCard number = number.
	self assert: creditCard expirationDate = date.
	self assert: creditCard owner = owner 
	! !

!TusLibrosTest methodsFor: '3 - Test Cashier' stamp: 'TomasRodriguez 6/4/2013 13:13'!
test09CreatingACashierWithAnEmptyCartShouldRaiseCanNotCreateACashierWithAnEmptyCartException

	self should: [self cashierWithEmptyCart ] raise: CanNotCreateACashierWithAnEmptyCart! !

!TusLibrosTest methodsFor: '3 - Test Cashier' stamp: 'TomasRodriguez 6/4/2013 13:13'!
test10CreatingACashierWithAnExpiredCreditCardShouldRaiseCanNotCreateACashierWithAnExpiredCreditCardException

	self should: [self cashierWithExpiredCreditCard ] raise: CanNotCreateACashierWithAnExpiredCreditCard! !

!TusLibrosTest methodsFor: '3 - Test Cashier' stamp: 'FedericoMendez 6/4/2013 23:17'!
test11ACashierWithACartWithBooksAndAValidCreditCardCanBeCreated
	| cashier |
	cashier := Cashier withCart: self cartWithBooks creditCard: self validCreditCard andSalesBook: nil.
	self assert: cashier cart = self cartWithBooks.
	self assert: cashier creditCard = self validCreditCard! !

!TusLibrosTest methodsFor: '3 - Test Cashier' stamp: 'FedericoMendez 6/4/2013 18:03'!
test12TheTotalAmountOfTheSaleShouldBeTheSumatoryOfThePricesOfEachBookInTheCart
	
	| cashier booksInCart amount |
	cashier := self validCashier .
	amount := 0.
	(cashier cart books) do: [:aBook | 
		amount := amount + (cashier cataloge priceOf: aBook)].
	
	self assert: cashier saleAmount = amount! !

!TusLibrosTest methodsFor: '4 - Test CheckOut' stamp: 'FedericoMendez 6/4/2013 23:31'!
test13AfterCheckOutTheSaleShouldBeRecordInTheSalesBook
	
	| salesBook cashier sale |
	
	salesBook := SalesBook new.
	cashier := Cashier withCart: self cartWithBooks creditCard: self validCreditCard andSalesBook: salesBook .
	
	self assert: salesBook isEmpty .
	sale := cashier checkOut .
	self deny: salesBook isEmpty .
	self assert: salesBook salesDone = 1.
	self assert: (salesBook includes: sale).
	! !

!TusLibrosTest methodsFor: '4 - Test CheckOut' stamp: 'FedericoMendez 6/5/2013 09:56'!
test14ThePurchasesOfAClientAreThePurchasesOfTheClientInTheSalesBook
	
	| salesBook cashier anotherCashier sale anotherSale |
	
	salesBook := SalesBook new.
	cashier := Cashier withCart: self cartWithBooks creditCard: self validCreditCard andSalesBook: salesBook .
	anotherCashier := Cashier withCart: self cartWithBooks creditCard: self validCreditCard andSalesBook: salesBook .
	sale := cashier checkOut .
	anotherSale := cashier checkOut .
	
	self assert: (salesBook salesOfTheClient: (sale client) ) size = 2.

	! !

!TusLibrosTest methodsFor: '4 - Test CheckOut' stamp: 'FedericoMendez 6/5/2013 11:21'!
test15TheTotalAmountSpentByAClientIsTheSumOfTheAmountsOfAllHisPurchases
	
	| salesBook cashier otherCashier anotherCashier sale otherSale anotherSale |
	
	salesBook := SalesBook new.
	cashier := Cashier withCart: self cartWithBooks creditCard: self validCreditCard andSalesBook: salesBook .
	otherCashier := Cashier withCart: self anotherCartWithBooks creditCard: self anotherValidCreditCard andSalesBook: salesBook .
	anotherCashier := Cashier withCart: self cartWithBooks creditCard: self validCreditCard andSalesBook: salesBook .

	sale := cashier checkOut .
	otherSale := otherCashier checkOut .
	anotherSale := anotherCashier checkOut .
	
	self assert: (salesBook totalSpentBy: (sale client))  = 900 
! !

!TusLibrosTest methodsFor: 'cashier' stamp: 'FedericoMendez 6/4/2013 23:18'!
validCashier
	^ Cashier withCart: self cartWithBooks creditCard: self validCreditCard andSalesBook: ''! !

!TusLibrosTest methodsFor: 'credit card' stamp: 'TomasRodriguez 6/4/2013 13:07'!
validCreditCard
	
	| expiredDate |
	expiredDate := Date today month next next .
	^ CreditCard withNumber: '9600000000000000' withExpirationDate: expiredDate propertyOf: 'Inspector Archundia'! !

Error subclass: #CanNotAddABookFromOtherEditorialToTheCart
	instanceVariableNames: 'book'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TusLibros'!

Error subclass: #CanNotCreateACashierWithAnEmptyCart
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TusLibros'!

Error subclass: #CanNotCreateACashierWithAnExpiredCreditCard
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TusLibros'!

Error subclass: #CanNotCreateACreditCardWithAnInvalidName
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TusLibros'!

Error subclass: #CanNotCreateACreditCardWithAnInvalidNumber
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TusLibros'!

Object subclass: #Cart
	instanceVariableNames: 'books cataloge clientID'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TusLibros'!

!Cart class methodsFor: 'as yet unclassified' stamp: 'FedericoMendez 6/4/2013 22:55'!
fromClient: aClientID whichMustHaveBooksFrom: aCataloge
	^ self new fromClient: aClientID whichMustHaveBooksFrom: aCataloge! !

!Cart methodsFor: 'as yet unclassified' stamp: 'TomasRodriguez 6/4/2013 13:41'!
= aCart

	^ books = aCart books! !

!Cart methodsFor: 'as yet unclassified' stamp: 'FedericoMendez 6/4/2013 14:04'!
add: aBook 

	(cataloge includes: aBook) ifFalse: [^ CanNotAddABookFromOtherEditorialToTheCart  signal].
	books add: aBook ! !

!Cart methodsFor: 'as yet unclassified' stamp: 'TomasRodriguez 6/4/2013 13:41'!
books

	^ books! !

!Cart methodsFor: 'as yet unclassified' stamp: 'TomasRodriguez 6/4/2013 12:18'!
booksQuantity
	
	^ books size! !

!Cart methodsFor: 'as yet unclassified' stamp: 'FedericoMendez 6/4/2013 14:05'!
cataloge

	^ cataloge! !

!Cart methodsFor: 'as yet unclassified' stamp: 'FedericoMendez 6/4/2013 22:57'!
client
	
	^ clientID ! !

!Cart methodsFor: 'as yet unclassified' stamp: 'FedericoMendez 6/4/2013 22:55'!
fromClient: aClientID whichMustHaveBooksFrom: aCataloge
	
	clientID := aClientID.
	cataloge := aCataloge ! !

!Cart methodsFor: 'as yet unclassified' stamp: 'TomasRodriguez 6/4/2013 12:18'!
initialize 
	
	books := Bag new.! !

!Cart methodsFor: 'as yet unclassified' stamp: 'TomasRodriguez 6/4/2013 12:19'!
isEmpty 

	^ books isEmpty ! !

!Cart methodsFor: 'as yet unclassified' stamp: 'TomasRodriguez 6/4/2013 12:18'!
ocurrencesOf: aBook

	^ books occurrencesOf: aBook ! !

Object subclass: #Cashier
	instanceVariableNames: 'cart creditCard cataloge amountOfSale salesBook'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TusLibros'!

!Cashier class methodsFor: 'as yet unclassified' stamp: 'FedericoMendez 6/4/2013 23:17'!
withCart: aCart creditCard: aCreditCard andSalesBook: aSalesBook
	aCart isEmpty
		ifTrue: [ ^ CanNotCreateACashierWithAnEmptyCart signal ].
	aCreditCard isExpired
		ifTrue: [ ^ CanNotCreateACashierWithAnExpiredCreditCard signal ].
	^ self new withCart: aCart creditCard: aCreditCard andSalesBook: aSalesBook! !

!Cashier methodsFor: 'as yet unclassified' stamp: 'FedericoMendez 6/4/2013 22:57'!
books
	
	^ cart books! !

!Cashier methodsFor: 'as yet unclassified' stamp: 'TomasRodriguez 6/4/2013 13:38'!
cart

	^ cart! !

!Cashier methodsFor: 'as yet unclassified' stamp: 'FedericoMendez 6/4/2013 14:17'!
cataloge

	^ cataloge! !

!Cashier methodsFor: 'as yet unclassified' stamp: 'FedericoMendez 6/4/2013 23:26'!
checkOut
	
	| sale |
	sale := Sale from: self.
	salesBook add: sale.
	^ sale! !

!Cashier methodsFor: 'as yet unclassified' stamp: 'FedericoMendez 6/4/2013 22:56'!
client
	
	^ cart client! !

!Cashier methodsFor: 'as yet unclassified' stamp: 'TomasRodriguez 6/4/2013 13:41'!
creditCard

	^ creditCard! !

!Cashier methodsFor: 'as yet unclassified' stamp: 'FedericoMendez 6/4/2013 14:25'!
saleAmount
	
	^ amountOfSale ! !

!Cashier methodsFor: 'as yet unclassified' stamp: 'FedericoMendez 6/4/2013 23:17'!
withCart: aCart creditCard: aCreditCard andSalesBook: aSalesBook 
		
	cart := aCart .
	creditCard := aCreditCard .
	cataloge := aCart cataloge.
	salesBook := aSalesBook .

	amountOfSale := 0.
	(aCart books) do: [ :aBook | 
		amountOfSale := amountOfSale + (aCart cataloge priceOf: aBook) ]! !

Object subclass: #Cataloge
	instanceVariableNames: 'books'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TusLibros'!

!Cataloge class methodsFor: 'as yet unclassified' stamp: 'TomasRodriguez 6/4/2013 11:20'!
withBooks: aSet 
	
	^ self new withBooks: aSet! !

!Cataloge methodsFor: 'as yet unclassified' stamp: 'FedericoMendez 6/4/2013 14:05'!
includes: aBook
	
	^ books includesKey: aBook ! !

!Cataloge methodsFor: 'as yet unclassified' stamp: 'FedericoMendez 6/4/2013 14:14'!
priceOf: aBook 
	
	^ books at: aBook ! !

!Cataloge methodsFor: 'as yet unclassified' stamp: 'FedericoMendez 6/4/2013 14:05'!
withBooks: aDictionary  
	
	books := aDictionary .! !

Object subclass: #CreditCard
	instanceVariableNames: 'number expirationDate owner'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TusLibros'!

!CreditCard class methodsFor: 'as yet unclassified' stamp: 'TomasRodriguez 6/4/2013 13:03'!
withNumber: aNumber withExpirationDate: anExpirationDate propertyOf: anOwner 
	
	(aNumber isAllDigits and: aNumber size = 16) ifFalse: [^ CanNotCreateACreditCardWithAnInvalidNumber signal].
	(anOwner size > 3) ifFalse: [^ CanNotCreateACreditCardWithAnInvalidName signal].
	^ self new withNumber: aNumber withExpirationDate: anExpirationDate propertyOf: anOwner ! !

!CreditCard methodsFor: 'as yet unclassified' stamp: 'TomasRodriguez 6/4/2013 13:42'!
= aCreditCard 

	^ number = aCreditCard number and: (owner = aCreditCard owner and: expirationDate = aCreditCard expirationDate )! !

!CreditCard methodsFor: 'as yet unclassified' stamp: 'TomasRodriguez 6/4/2013 13:12'!
expirationDate

	^ expirationDate! !

!CreditCard methodsFor: 'as yet unclassified' stamp: 'TomasRodriguez 6/4/2013 12:41'!
isExpired
	
	^ Date today month > expirationDate ! !

!CreditCard methodsFor: 'as yet unclassified' stamp: 'TomasRodriguez 6/4/2013 13:11'!
number

	^ number! !

!CreditCard methodsFor: 'as yet unclassified' stamp: 'TomasRodriguez 6/4/2013 13:12'!
owner

	^ owner! !

!CreditCard methodsFor: 'as yet unclassified' stamp: 'TomasRodriguez 6/4/2013 12:41'!
withNumber: aLargePositiveInteger withExpirationDate: anExpirationDate propertyOf: anOwner 
	
	number := aLargePositiveInteger .
	expirationDate := anExpirationDate .
	owner := anOwner ! !

Object subclass: #Sale
	instanceVariableNames: 'clientID saleAmount booksSold'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TusLibros'!

!Sale class methodsFor: 'as yet unclassified' stamp: 'FedericoMendez 6/4/2013 23:23'!
from: aCashier 

	^ self new from: aCashier ! !

!Sale methodsFor: 'as yet unclassified' stamp: 'FedericoMendez 6/4/2013 23:32'!
= aSale

	^ clientID = aSale client and: (saleAmount = aSale saleAmount and: booksSold = aSale booksSold )! !

!Sale methodsFor: 'as yet unclassified' stamp: 'FedericoMendez 6/4/2013 23:28'!
booksSold 

	^ booksSold ! !

!Sale methodsFor: 'as yet unclassified' stamp: 'FedericoMendez 6/4/2013 23:28'!
client

	^ clientID .! !

!Sale methodsFor: 'as yet unclassified' stamp: 'FedericoMendez 6/4/2013 23:25'!
from: aCashier 
	
	clientID := aCashier client .
	saleAmount := aCashier saleAmount .
	booksSold := aCashier books .! !

!Sale methodsFor: 'as yet unclassified' stamp: 'FedericoMendez 6/4/2013 23:28'!
saleAmount 

	^ saleAmount .! !

Object subclass: #SalesBook
	instanceVariableNames: 'sales'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TusLibros'!

!SalesBook methodsFor: 'as yet unclassified' stamp: 'FedericoMendez 6/4/2013 23:26'!
add: aSale 
	
	sales add: aSale ! !

!SalesBook methodsFor: 'as yet unclassified' stamp: 'FedericoMendez 6/4/2013 23:27'!
includes: aSale 

	^ sales includes: aSale ! !

!SalesBook methodsFor: 'as yet unclassified' stamp: 'FedericoMendez 6/4/2013 23:24'!
initialize 

	sales := OrderedCollection new.! !

!SalesBook methodsFor: 'as yet unclassified' stamp: 'FedericoMendez 6/4/2013 23:23'!
isEmpty
	
	^ sales isEmpty .! !

!SalesBook methodsFor: 'as yet unclassified' stamp: 'FedericoMendez 6/4/2013 23:27'!
salesDone
	
	^ sales size ! !

!SalesBook methodsFor: 'as yet unclassified' stamp: 'FedericoMendez 6/5/2013 10:47'!
salesOfTheClient: aClient
	
	| totalSales salesOfTheClient |
	
	totalSales := sales size .
	salesOfTheClient := OrderedCollection new .
		
	[ (totalSales > 0) ] whileTrue:
								[
									((sales at: totalSales) client  = aClient) ifTrue: [ salesOfTheClient add: (sales at: totalSales) ] . 
									totalSales := totalSales - 1 .
								] . 
	
	^ salesOfTheClient ! !

!SalesBook methodsFor: 'as yet unclassified' stamp: 'FedericoMendez 6/5/2013 10:42'!
totalSpent: aClient 

	| salesOfTheClient index total |
	
	salesOfTheClient := self salesOfTheClient: aClient .
	index := salesOfTheClient size .
	total := 0 .
	
	[ (index > 0) ] whileTrue:
						[
							total := (total + ((salesOfTheClient at: index) saleAmount)) .
							index := index - 1.
						] .
	
	^ total! !

!SalesBook methodsFor: 'as yet unclassified' stamp: 'FedericoMendez 6/5/2013 11:20'!
totalSpentBy: aClient 

	| salesOfTheClient index total |
	
	salesOfTheClient := self salesOfTheClient: aClient .
	index := salesOfTheClient size .
	total := 0 .
	
	[ (index > 0) ] whileTrue:
						[
							total := (total + ((salesOfTheClient at: index) saleAmount)) .
							index := index - 1.
						] .
	
	^ total! !
